//+------------------------------------------------------------------+
//|                                            elCid_noLoss.mq4      |
//|                                         writen by Michel         |
//+------------------------------------------------------------------+
#property copyright "el Cid"


extern double Lots = 0.1;
extern int Target = 75;
extern int Magic = 522;

int start()
{   
   int i, BuyTicket = 0, SellTicket = 0, BuyStopTicket = 0, SellStopTicket = 0;
   double Tgt, BuyCount = 0, SellCount = 0, BuyStopCount = 0, SellStopCount = 0, BuyPrice, SellPrice;
   
   for(i = OrdersTotal()-1; i >= 0; i --)
   {
      if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderSymbol()!= Symbol() || OrderMagicNumber() != Magic) continue;
      if(OrderType() == OP_BUY)
      {
         if(SellTicket > 0) {OrderCloseBy(OrderTicket(),SellTicket,Yellow); return(0);}
         BuyTicket = OrderTicket();
         BuyCount = OrderLots();
         BuyPrice = OrderOpenPrice();
      }
      if(OrderType() == OP_SELL)
      {
         if(BuyTicket > 0) {OrderCloseBy(OrderTicket(),BuyTicket,Yellow); return(0);}
         SellTicket = OrderTicket(); 
         SellCount = OrderLots();
         SellPrice = OrderOpenPrice();
      }                  
      if(OrderType() == OP_BUYSTOP)
      {
         BuyStopTicket = OrderTicket();
         BuyStopCount = OrderLots();
      }
      if(OrderType() == OP_SELLSTOP)
      {
         SellStopTicket = OrderTicket();
         SellStopCount = OrderLots();
      }
   
   } 
 
   Tgt = Target * Point;
   
   if(BuyCount + SellCount == 0) //a new session begins...
   {
      if(BuyStopTicket > 0) OrderDelete(BuyStopTicket,CLR_NONE);
      if(SellStopTicket > 0) OrderDelete(SellStopTicket,CLR_NONE);
      // Random entry
      if(MathMod(Seconds(), 2) < 0.5)
         OrderSend(Symbol(), OP_BUY, Lots, Ask, 0, Ask-Tgt*2, Ask+Tgt, "", Magic, 0, DeepSkyBlue);
      else 
         OrderSend(Symbol(), OP_SELL, Lots, Bid, 0, Bid+Tgt*2, Bid-Tgt, "", Magic, 0, DarkOrange);
      return(0);
   }
   
   if(BuyCount > 0 && SellStopCount == 0)  OrderSend(Symbol(),OP_SELLSTOP,BuyCount * 3,BuyPrice-Tgt,0,BuyPrice+Tgt,BuyPrice-Tgt*2,"",Magic, 0, DarkOrange);
   if(SellCount > 0 && BuyStopCount == 0) OrderSend(Symbol(),OP_BUYSTOP,SellCount * 3,SellPrice+Tgt,0,SellPrice-Tgt,SellPrice+Tgt*2,"",Magic, 0, DeepSkyBlue);
 
}
//+------------------------- That's all -----------------------------------------+

